

from mathutils import Vector

from bge import logic, events

import json


GAMEPATH = logic.expandPath("//")+"BLENDS\\"

try:
	name = GAMEPATH+"level_info.json"
	file = open(name, "r")
	INFO = json.load(file)
	file.close()
except OSError:
	print("NOTICE: 'BLENDS\level_info.json' not found")
	INFO = {}


BLENDS = logic.getBlendFileList(GAMEPATH)
print(GAMEPATH)

ROOT = logic.getCurrentController().owner
SCENE = logic.getCurrentScene()
LEVELS = []

for blend in BLENDS:
	pos = len(LEVELS)*-2
	obj = SCENE.addObject("Level", ROOT, 0)
	obj.worldPosition = (0, pos, 0)
	txt = obj.childrenRecursive["Level.Text"]
	txt.text = blend.split(".blend")[0]
	dict = {"Root":obj, "Text":txt, "Map":blend, "Pos":pos, "Desc":INFO.get(blend,"")}
	LEVELS.append(dict)
	print("Level Found:", blend)


def ListManager(cont):
	mse = logic.mouse.events

	owner = cont.owner

	prv_txt = SCENE.objects["PreviewText"]
	prv_img = SCENE.objects["PreviewImage"]

	blend = None
	descr = ""

	if mse[events.WHEELDOWNMOUSE] in [1,2]:
		if owner["SCROLL"] < len(LEVELS):
			owner["SCROLL"] += 1
	elif mse[events.WHEELUPMOUSE] in [1,2]:
		if owner["SCROLL"] > 0:
			owner["SCROLL"] -= 1

	scroll = owner["SCROLL"]*2

	for dict in LEVELS:
		root = dict["Root"]
		text = dict["Text"]
		pos = dict["Pos"]
		root.worldPosition[1] -= (root.worldPosition[1]-(scroll+pos))*0.1
		if root["MOUSE"] == True:
			blend = dict["Map"]
			descr = dict["Desc"]
			root.color = GammaCorrect([0.3, 0.3, 0.3, 1])
			text.color = GammaCorrect([1.0, 0.5, 0.0, 1])
		else:
			root.color = GammaCorrect([0.2, 0.2, 0.2, 1])
			text.color = GammaCorrect([0.7, 0.7, 0.7, 1])

	prv_txt.text = descr

	if blend != None and mse[events.LEFTMOUSE] == 1:
		logic.startGame(GAMEPATH+blend)


def GammaCorrect(list):
	for i in range(len(list)):
		list[i] = list[i]**2.2
	return list
